{% extends "ajax/game/town/town.html.twig" %}
{% block title %}{{'Das Stadttor von "{townname}"'|trans({"{townname}": town.name}, 'game')|raw}}{% endblock %}
{% block tutorial %}
    <div x-tutorial-content="4.text3" class="toplevel text arrow-down">
        <div class="help">
            {% if town.door %}
                <p>{% trans from "help" %}
                        Das Stadttor ist geöffnet.
                    {% endtrans %}</p>
                <p>{% trans from "help" %}
                        Klick hier, um <strong>in die Wüste zu gehen</strong>... Sei jedoch vorsichtig!
                    {% endtrans %}</p>
                <button x-advance-tutorial="complete">{{ 'Weiter...'|trans({},'help') }}</button>
            {% else %}
                <p>{% trans from "help" %}
                        Du kannst <strong>das Stadttor</strong> in diesem Bereich öffnen... Achtung: Wenn das Tor beim allnächtlichen <strong>Angriff der Zombiehorde</strong> offen steht, kann das für die Stadt fatale Folgen haben...<strong></strong>
                    {% endtrans %}</p>
            {% endif %}
        </div>
    </div>
{% endblock %}
{% block content %}
    {% set hour = "now"|date("G") %}
    <div class="row">
        <div class="cell rw-12 town-banner town-banner-door-{% if town.door %}open{% else %}closed{% endif%} time-{{ hour }} {% if conf.isNightTime %}night{% endif %}"></div>
    </div>

    {% embed "ajax/game/town/door_tabs.html.twig" with {'door_section': door_section, 'has_battlement': has_battlement} %}
    {% endembed %}

    <div class="row-flex wrap town-summary">
        <div class="padded cell rw-4 ellipsis row-header"><img src="{{ asset('build/images/item/item_plate.gif') }}" alt="" /> {{'Stadtverteidigung'|trans({}, 'game')}}</div>
        <div class="padded cell rw-8 ellipsis row-detail">{{def}} <img src="{{ asset('build/images/icons/small_def.gif') }}" alt="" /> (<span class="link" x-ajax-href="{{ path('town_dashboard') }}">{{'Details ansehen'|trans({}, 'game')}}</span>)</div>
        <div class="padded cell rw-4 ellipsis row-header"><img src="{{ asset('build/images/item/item_door.gif') }}" alt="" /> {{'Lage'|trans({}, 'game')}}</div>
        <div class="padded cell rw-8 ellipsis row-detail">
            {% if town.door and town.devastated %}
                <span class="warning">{{'Stadttor zerstört!'|trans({}, 'game')}}</span>
            {% elseif (town.door) %}
                <span class="warning">{{'Stadttor geöffnet'|trans({}, 'game')}}</span>
            {% else %}
                {{'Stadttor geschlossen'|trans({}, 'game')}}
            {% endif %}
            <span class="small">(<span class="link" x-ajax-href="{{ path("town_citizens") }}">{{'Wer ist draußen?'|trans({}, 'game')}}</span>)</span>
        </div>
    </div>

    <div class="row">
        <div class="padded cell rw-6 rw-md-12">
            {% if not app.user.expert %}

                {% set has_packed_food = false %}
                {% set has_packed_water = false %}
                {% for item in app.user.activeCitizen.inventory.items %}
                    {% if item.prototype.hasProperty('is_water') %}{% set has_packed_water = true %}{% endif %}
                    {% if item.prototype.hasProperty('food') %}    {% set has_packed_food  = true %}{% endif %}
                {% endfor %}

                {% if not has_packed_food and not has_packed_water %}
                    <div x-conditional-help="door_equipment" class="no-arrow">
                        <p>{% trans from "help" %}
                                Es wäre vielleicht nicht verkehrt etwas <strong>Proviant</strong> (Nahrung und/oder Wasser) einzupacken, bevor du die Stadt verlässt... Gehe dazu in den Bereich <strong>Mein Zuhause</strong>.
                            {% endtrans %}</p>
                        <button x-confirm-conditional-help="door_equipment" x-temp="1">{{ 'Schließen'|trans({},'global') }}</button>
                    </div>
                {% endif %}
            {% endif %}

            {% if not can_go_out %}
                <div class="help">
                    <p>
                        {{'<strong>Du bist erschöpft</strong>, du kannst deshalb weder <strong>in die Außenwelt gehen</strong>, noch <strong>das Stadttor öffnen</strong>, noch <strong>es schließen</strong>.'|trans({}, 'game')|raw}}
                    </p>
                    <p>
                        {{'Trinke oder nimm einen Happen zu dir, aber unternimm etwas, um wieder in Schuss zu kommen!'|trans({}, 'game')}}
                    </p>
                </div>
            {% else %}
            {% if not town.devastated %}
                <div class="help">
                    {% trans from 'game' %}
                        Du kannst von hier aus die Stadt verlassen und die Außenwelt erkunden. Vergiss aber nicht, um Mitternacht das Tor zu schließen!
                    {% endtrans %}
                </div>

                {% if banished %}
                    <div class="note note-warning">
                        {% trans from 'game' %}
                            Du wurdest verbannt und kannst daher das Stadttor weder öffnen noch schließen.
                        {% endtrans %}
                    </div>
                {% endif %}
            {% else %}
                <div class="note note-critical">
                    {% trans from 'game' %}
                        Das Stadttor wurde bei einem besonders furchtbaren Angriff aus den Angeln gerissen und in die Aussenwelt geschleudert. Du solltest dich heute Nacht besser nicht hier aufhalten, sonst wird diese Stadt dein Grab.
                    {% endtrans %}
                    <br/><br/>
                    <strong>{% trans from 'game' %}
                        Das passiert eben, wenn man eine Stadt ohne einen einzigen Einwohner zurücklässt.
                    {% endtrans %}</strong>
                </div>
            {% endif %}
            <h5>{% trans from 'game' %}Meine Aktionen{% endtrans %}</h5>
                <div class="actions-box">
            {% if not banished %}
                {% if town.door %}
                    <div style="margin-bottom: 5px;">
                        <button id="door_closer" {% if town.devastated %}disabled{% endif %}><img alt="" src="{{ asset('build/images/icons/small_action.gif') }}" />{% trans from 'game' %}Tor schließen{% endtrans %} (<div class="ap">1</div>)</button>
                        {% if town.devastated %}
                            <div class="tooltip">{{ 'Das Stadttor ist zerstört!'|trans({},'game') }}</div>
                        {% else %}
                            <div class="tooltip help">{{ 'Achtung! Alle Spieler, die sich außerhalb der Stadt befinden, können danach nicht mehr rein.'|trans({},'game') }}</div>
                        {% endif %}
                    </div>
                {% else %}
                    <button id="door_opener" {% if door_locked %}disabled{% endif %}><img alt="" src="{{ asset('build/images/icons/small_action.gif') }}" />{% trans from 'game' %}Tor öffnen{% endtrans %} (<div class="ap">1</div>)</button>
                {% endif %}
            {% endif %}
            {% if show_ventilation %}
                <button id="door_exit_hero" {% if not allow_ventilation or not can_go_out %}disabled{% endif %}>
                    <img alt="" src="{{ asset('build/images/icons/star.gif') }}">{% trans from 'game' %}Durch die Lüftungsschächte klettern (out){% endtrans %}
                    <div class="tooltip help">{{ 'Diese Aktion wird durch ein Gebäude in der Stadt ermöglicht (nur Helden können sie verwenden).'|trans({},'game') }}</div>
                </button>
            {% endif %}
            {% if show_sneaky %}
                <button id="door_exit_sneak" {% if not town.door or not can_go_out %}disabled{% endif %}><img alt="" src="{{ asset('build/images/roles/ghoul.gif') }}">
                    {% trans from 'game' %}Aus der Stadt schleichen{% endtrans %}
                    <div class="tooltip help">{{ 'Mit dieser Aktion kannst du die Stadt verlassen, ohne dass es ins Stadtregister eingetragen wird.'|trans({},'game') }}</div>
                </button>
            {% endif %}
            <button id="door_exit" {% if not town.door or not can_go_out %}disabled{% endif %}><img alt="" src="{{ asset('build/images/icons/small_move.gif') }}" />{% trans from 'game' %}Stadt verlassen{% endtrans %}</button>
            <button x-ajax-href="{{ path('town_routes') }}"><img alt="" src="{{ asset('build/images/item/item_bagxl.gif') }}" />{{ 'Route planen...'|trans({},'game') }}</button>
                </div>
            {% if town.door %}
                <div style="font-size: 1.2rem;">{{ 'Das Stadttor ist <span class="critical">geöffnet</span>! Achtung: Wenn das Tor geschlossen wird, können alle Spieler, die sich außerhalb der Stadt befinden, nicht mehr rein.'|trans({}, 'game')|raw }}</div>
            {% endif %}
            {% endif %}
        </div>
        <div class="padded cell rw-6 rw-md-12">
            <div id="door-map" x-react-mount="map" x-react-data="{{ map_public_json }}"></div>
        </div>
    </div>

    <p class="ambiant">
        {{'Das Stadttor ist Teil einer Festungsmauer, die den Großteil der Zombies abwehrt. Solltest du vergessen es am Abend zu schließen, kannst du dich auf Qualen einstellen, die deine schlimmsten Alpträume weit übertreffen.'|trans({}, 'game')}}
    </p>

    <div class="row">
        <h5>{{ 'Stadttor-Register'|trans({},'game') }} <a class="float-right link" x-ajax-href="{{ path("game_newspaper") }}">{{ 'Das Gesamtregister ansehen'|trans({}, 'game') }}<div class="tooltip normal">{{ 'Dieser Link bringt dich zum <strong>Großen Register</strong>. Darin werden alle wichtigen Handlungen und Aktionen der Stadtbürger gespeichert...'|trans({}, 'game')|raw }}</div></a></h5>
        <div class="cell rw-12">
            {% embed "ajax/game/log.html.twig" with {'log_content': log, 'log_source': path('town_door_log_controller') } %}
            {% endembed %}
        </div>
    </div>
{% endblock %}
{% block js %}
    {{ parent() }}
    <script>
        {% embed "scripts/log.js.twig" %}{% endembed %}

        const handleDoor = function(element, action) {
            if (!element) return;
            element.addEventListener('click', function() {
                if (!confirm('{{ 'Bestätigen?'|trans({},'global')|e('js') }}'))
                    return;
                $.ajax.easySend( '{{ path('town_door_control_controller') }}', {
                        action: action
                    },
                    function () {
                        $.ajax.load(null, '{{ path('town_door') }}', true);
                    } );
            });
        };

        {% if can_go_out %}
            handleDoor( document.getElementById('door_opener'), 'open' );
            handleDoor( document.getElementById('door_closer'), 'close' );

            document.getElementById('door_exit').addEventListener('click', function() {
                $.ajax.easySend( '{{ path('town_door_exit_controller') }}', {},
                    function () {
                        $.ajax.load(null, '{{ path('game_landing') }}', true);
                    } );
            });

            {% if show_ventilation and allow_ventilation %}
                document.getElementById('door_exit_hero').addEventListener('click', function() {
                    $.ajax.easySend( '{{ path('town_door_exit_controller', {'special': 'hero'}) }}', {},
                        function () {
                            $.ajax.load(null, '{{ path('game_landing') }}', true);
                        } );
                });
            {% endif %}
        {% endif %}

        {% if show_sneaky %}
            $.html.addEventListenerAll( '#door_exit_sneak', 'click', () => {
                if (!confirm('{{ 'Bestätigen?'|trans({},'global')|e('js') }}'))
                    return;
                $.ajax.easySend( '{{ path('town_door_exit_controller', {'special': 'sneak'}) }}', {},
                    function () {
                        $.ajax.load(null, '{{ path('game_landing') }}', true);
                    } );
            } );
        {% endif %}
    </script>
{% endblock %}
